A Onelab model for 3D scattering problems in nanophotonics.

## Synopsis

This project contains a [Onelab](http://onelab.info/wiki/ONELAB) model for solving various 3D electromagnetic problems on an isolated arbitrary object :
* T-matrix computation: See https://arxiv.org/abs/1802.00596 for details
* Quasi-normal modes
* Plane wave response
* Green's function

## Installation

This model requires the following programs:
* [gmsh](http://www.gmsh.info/)
* [getdp](http://www.getdp.info/) compiled with python support (see below)
* python (>3.5.x) with numpy, scipy and matplotlib

## Running the model

Open `scattering.pro` with Gmsh.

## Authors

Guillaume Demésy and Brian Stout

## Installation Note
To enable python support (Python[] function) in GetDP, follow [these instructions](https://gitlab.onelab.info/getdp/getdp/wikis/GetDP-compilation) (complex arithmetic) and add to the final cmake line:

`-DENABLE_PYTHON=ON -DPYTHON_LIBRARY=/path/to/pythonlib -DPYTHON_INCLUDE_DIR=/path/to/pythoninclude`
*  On Debian/Ubuntu systems, for python3.6 installed with apt-get,
    * `/path/to/pythonlib` is `/usr/lib/x86_64-linux-gnu/libpython3.6m.so`
    * `/path/to/python/include` is `/usr/include/python3.6m`
* For python versions installed through anaconda in some an environement (e.g. py36 below), a common location is:
    * `/somepath/anaconda3/envs/py36/lib/libpython3.6m.so`
    * `/somepath/anaconda3/envs/py36/include/python3.6m`
